{==============================================================================|
| Project : Mouse test file
|==============================================================================|
| Project version : 1.0
|==============================================================================|
| Content : 
|==============================================================================|
| Author : Jiri Provaznik
|==============================================================================|
| URL : www.provaz.cz/sector02
|==============================================================================|
| Copyright: 
|  The Initial Developer of the Original Code is Jiri Provaznik 
|  (Czech Republic). Copyright (C) 2007. All Rights Reserved.
|==============================================================================|
| History: 
|==============================================================================}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Spin, Shellapi, Buttons;

type
  TMyPoint = class(TCollectionItem)
  private
    fpoint: TPoint;
  published
    property Point: TPoint read fpoint write fpoint;
    property X : integer read fpoint.x write fpoint.x ;
    property Y : integer read fpoint.y write fpoint.y ;
  end;

  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    Label2: TLabel;
    Button1: TButton;
    ListView1: TListView;
    seSegments: TSpinEdit;
    Image1: TImage;
    TabSheet2: TTabSheet;
    PanelLockMouse: TPanel;
    TabSheet3: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtnClick1: TBitBtn;
    BitBtnClick2: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtnAClick1: TBitBtn;
    BitBtnAClick2: TBitBtn;
    TabSheet4: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    RichEdit1: TRichEdit;
    Basic: TTabSheet;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListView1Data(Sender: TObject; Item: TListItem);
    procedure PanelLockMouseClick(Sender: TObject);
    procedure BitBtnClick1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtnAClick1Click(Sender: TObject);
    procedure BitBtnAClick2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private declarations }
    Points : TCollection;
    procedure ClearImg;
    procedure CreateLine;
    procedure MouseWatch;
    procedure LoadRTFVersion;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{------------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Points := TCollection.Create(TMyPoint);
  ClearImg;
  LoadRTFVersion;
  PageControl1.ActivePageIndex := 0;
end;
{------------------------------------------------------------------------------}
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Points);
  ClipCursor(nil);
end;
{------------------------------------------------------------------------------}
procedure TForm1.ClearImg;
begin
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(Image1.Canvas.ClipRect);
end;
{------------------------------------------------------------------------------}
procedure TForm1.CreateLine;
var
  i, xs, ys : integer;
begin
  Randomize;
  Points.Clear;
  xs := +1;
  ys := +1;

  with TMyPoint(Points.Add) do
  begin
    x := Random(Image1.Canvas.ClipRect.Right);
    y := Random(Image1.Canvas.ClipRect.Bottom);
    Image1.Canvas.MoveTo(x,y);
  end;

  for i := 0 to seSegments.Value do
  begin
    with TMyPoint(Points.Add) do
    begin
      x := TMyPoint(Points.Items[Points.Count-2]).X + (Random(5)*xs);
      y := TMyPoint(Points.Items[Points.Count-2]).Y + (Random(5)*ys);
      if (x > Image1.Canvas.ClipRect.Right) or (x < Image1.Canvas.ClipRect.Left) then
      begin
        xs := xs * -1;
        x := TMyPoint(Points.Items[Points.Count-2]).X + (Random(5)*xs);
      end;

      if (y > Image1.Canvas.ClipRect.Bottom) or (y < Image1.Canvas.ClipRect.Top) then
      begin
        ys := ys * -1;
        y := TMyPoint(Points.Items[Points.Count-2]).Y + (Random(5)*ys);
      end;

      Image1.Canvas.Pen.Color := clBlack;
      Image1.Canvas.LineTo(x,y);
    end;

  end;

  ListView1.Items.Count := Points.Count;
  ListView1.Refresh;
end;
{------------------------------------------------------------------------------}
procedure TForm1.Button1Click(Sender: TObject);
begin
  ClearImg;
  CreateLine;
  MouseWatch;
end;
{------------------------------------------------------------------------------}
procedure TForm1.ListView1Data(Sender: TObject; Item: TListItem);
begin
  if (Item.Index<=(Points.Count-1)) then
  begin
    Item.Caption := IntToStr(Item.Index);
    Item.SubItems.Add(IntToStr(TMyPoint(Points.Items[Item.Index]).X));
    Item.SubItems.Add(IntToStr(TMyPoint(Points.Items[Item.Index]).Y));
  end
  else
  begin
    ListView1.Items.Count := Points.Count;
  end;
end;
{------------------------------------------------------------------------------}
procedure TForm1.MouseWatch;
var
  i : integer;
  pt,pt_start : TPoint;
begin
  GetCursorPos(pt_start);
  for i := 0 to Points.Count-1 do
  begin
    pt := TMyPoint(Points.Items[i]).Point;
    pt.x := pt.x + Image1.ClientOrigin.x;
    pt.y := pt.y + Image1.ClientOrigin.y;
    SetCursorPos(pt.x, pt.y);
    Application.ProcessMessages;
    Sleep(10);
  end;
  SetCursorPos(pt_start.x,pt_start.y);
end;
{------------------------------------------------------------------------------}
procedure TForm1.PanelLockMouseClick(Sender: TObject);
var
  r : TRect;
begin
  if PanelLockMouse.Tag = 0 then
  begin
    PanelLockMouse.Tag := 1;
    PanelLockMouse.Caption := 'Click here to UNLOCK Cursor from this rectangle';
    r := PanelLockMouse.ClientRect;
    r.Left := r.Left + PanelLockMouse.ClientOrigin.x;
    r.Right := r.Right + PanelLockMouse.ClientOrigin.x;
    r.Top := r.Top + PanelLockMouse.ClientOrigin.y;
    r.Bottom := r.Bottom + PanelLockMouse.ClientOrigin.y;
    ClipCursor(@r);
  end
  else
  begin
    PanelLockMouse.Tag := 0;
    PanelLockMouse.Caption := 'Click here to LOCK Cursor in this rectangle';
    ClipCursor(nil);
  end;
end;
{------------------------------------------------------------------------------}
procedure TForm1.BitBtnClick1Click(Sender: TObject);
begin
  (Sender as TBitBtn).Tag := (Sender as TBitBtn).Tag + 1;
  (Sender as TBitBtn).Caption := IntToStr((Sender as TBitBtn).Tag);
end;
{------------------------------------------------------------------------------}
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  pt,pt_start : TPoint;
begin
  //--- get start position ---
  GetCursorPos(pt_start);
  pt := pt_start;
  while pt.x<(BitBtnClick2.ClientOrigin.x+BitBtnClick2.Width) do
  begin
    pt.x := pt.x + 10;
    //--- mouse move ---
    Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_MOVE,
                Trunc(Pt.x*(65535/screen.Width)) , Trunc(Pt.y*(65535/screen.Height)), 0, 0) ;
    Application.ProcessMessages;

    //--- click on button ---
    if ((pt.x>=BitBtnClick1.ClientOrigin.x ) and (pt.x<=BitBtnClick1.ClientOrigin.x+BitBtnClick2.Width))
       or
       ((pt.x>=BitBtnClick2.ClientOrigin.x ) and (pt.x<=BitBtnClick2.ClientOrigin.x+BitBtnClick1.Width)) then
    begin
       Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN,
               Trunc(Pt.x*(65535/screen.Width)) , Trunc(Pt.y*(65535/screen.Height)), 0, 0) ;
       Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP,
               Trunc(Pt.x*(65535/screen.Width)) , Trunc(Pt.y*(65535/screen.Height)), 0, 0) ;
    end;

    Sleep(10);
  end;
  //--- return to start position ---
  SetCursorPos(pt_start.x,pt_start.y);
end;
{------------------------------------------------------------------------------}
procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  BitBtnClick1.Tag := -1;
  BitBtnClick1.OnClick(BitBtnClick1);
  BitBtnClick2.Tag := -1;
  BitBtnClick2.OnClick(BitBtnClick2);
end;
{------------------------------------------------------------------------------}
procedure TForm1.BitBtnAClick1Click(Sender: TObject);
var
  pt : TPoint;
begin
  //--- screen position ---
  pt.x := BitBtnClick1.ClientOrigin.x + trunc(BitBtnClick1.Width/2);
  pt.y := BitBtnClick1.ClientOrigin.y + trunc(BitBtnClick1.Height/2);
  //--- mouse absolute position ---
  pt.x := Trunc(Pt.x*(65535/screen.Width));
  pt.y := Trunc(Pt.y*(65535/screen.Height));
  //--- mouse move ---
  Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_MOVE,
              pt.x, pt.y, 0, 0) ;
  //--- left mouse button down ---
   Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN,
              pt.x, pt.y , 0, 0) ;
  //--- left mouse button up ---
   Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP,
              pt.x, Pt.y, 0, 0) ;

   Application.ProcessMessages;
end;
{------------------------------------------------------------------------------}
procedure TForm1.BitBtnAClick2Click(Sender: TObject);
var
  pt : TPoint;
begin
  //--- screen position ---
  pt.x := BitBtnClick2.ClientOrigin.x + trunc(BitBtnClick2.Width/2);
  pt.y := BitBtnClick2.ClientOrigin.y + trunc(BitBtnClick2.Height/2);
  //--- mouse absolute position ---
  pt.x := Trunc(Pt.x*(65535/screen.Width));
  pt.y := Trunc(Pt.y*(65535/screen.Height));
  //--- mouse move ---
  Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_MOVE,
              pt.x, pt.y, 0, 0) ;
  //--- left mouse button down ---
   Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN,
              pt.x, pt.y , 0, 0) ;
  //--- left mouse button up ---
   Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP,
              pt.x, Pt.y, 0, 0) ;

   Application.ProcessMessages;
end;
{------------------------------------------------------------------------------}
procedure TForm1.LoadRTFVersion;
begin
  if FileExists(ExtractFilePath(Application.ExeName)+'\info.rtf') then
    RichEdit1.Lines.LoadFromFile(ExtractFilePath(Application.ExeName)+'\info.rtf');
end;
{------------------------------------------------------------------------------}
procedure TForm1.Label3Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar((sender as TLabel).Caption),'','',SW_SHOWNORMAL);
end;
{------------------------------------------------------------------------------}
procedure TForm1.BitBtn3Click(Sender: TObject);
var
  i : integer;
  pt,pt_start : TPoint;
begin
  GetCursorPos(pt_start);
  pt := pt_start;
  for i := 0 to 50 do
  begin
    pt.x := pt.x + 1;
    pt.y := pt.y + 1;
    SetCursorPos(pt.x, pt.y);
    Application.ProcessMessages;
    Sleep(10);
  end;
  SetCursorPos(pt_start.x,pt_start.y);
end;
{------------------------------------------------------------------------------}
procedure TForm1.BitBtn4Click(Sender: TObject);
var
  pt : TPoint;
begin
  GetCursorPos(pt);

  pt.x := pt.x+50;
  pt.y := pt.y+50;
  //--- mouse absolute position ---
  pt.x := Trunc(Pt.x*(65535/screen.Width));
  pt.y := Trunc(Pt.y*(65535/screen.Height));
  //--- mouse move ---
  Mouse_Event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_MOVE, pt.x, pt.y, 0, 0) ;
end;

end.
